//+------------------------------------------------------------------+
//|                                                      T101_VininE |
//|                                Copyright  2008, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "e-mail: vinin@mail.ru"

extern string  _________TX0_________ = "========  =========";
extern int     Magic                 = 20081018;
extern bool    CheckNewBar           = TRUE;
extern bool    ShowCommentInChart    = TRUE;                        //    .
extern double  Lot                   = 0.1;
extern int     ShiftBack             = 8;
extern int     CorrelationBar        = 24;
extern int     Revers_Otkat               = -1;                          //    
extern string  ListSymbol            = "AUDCAD,AUDCHF,AUDJPY,AUDNZD,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURJPY,EURGBP,EURNZD,EURUSD,NZDUSD,NZDJPY,GBPUSD,GBPCHF,GBPJPY,USDCHF,USDJPY,USDCAD";
extern int     StopLoss              = 100;
extern int     TakeProfit            = 100;
extern int     Bar_Begins            = 1;
extern int     Slip                  = 3;
extern int     MinProfit             = 20;                          //     MINLOT
extern int     MaxProfit             = 1000;
extern bool    SemaphoreOn           = TRUE;                         // ,       
extern bool    PrintCom              = TRUE;                         //  
extern string  Setup_TrailingProfit  = " TrailingProfit";
extern int     Use_TraillingProfit   = 0;                           //   Profit
extern int     Trail_Start           = 5;                           //      
extern int     Trail_Value           = 5;                           //   
extern string  Setup_Services        = "*** ***";
extern string  Close_Trade_Symbol    = "";                          //          "ALL"
//#include       <b-MyLots(Multi).mqh>
extern int     StopMarginPercent     = 50;                          //           
extern int     RiskDepoPercent       = 30;                          //     Depo ( )   
extern int     StopYbutok            = 1000;                        //     .   
#include       <b-LibTradeContext.mqh>
#include       <LibOrderReliableRU.mqh>       //      
#include       <ErrorDescription_RUS.mqh>
#include       <WinUser32.mqh>
//+------------------------------------------------------------------+
double   gd_Profit, gd_MinEquity, gd_MinMargin, gd_BeginBalance, gd_MaxProsadka, gd_MaxZalog, gd_Pribul,
         WorkPips[];
string   gs_INF, gs_NameGV, gs_msg, gs_Close,
         WorkSymbol[], Array_Com[7];
int      WorkOp[], WorkSort[], WorkCorr[], WorkTicket[],// Order_Count[6],
         WorkCount, gi_flagTrailProfit, gi_flag_NULLStops, gi_SMB, gi_History, gi_BrokerDecimal, gi_int, new_Day,
         shift = 0,
         WorkPrevTime = 0,
         Ind_Base = -1;
bool     gb_InfoPrint = false,
         gb_Pause = False,
         RealTrade = True;
//+------------------------------------------------------------------+
int init()
{
    string ls_inf = "   :\n";
    gs_NameGV = "T101 Vinin";
//----
    //            -      10  -     
    if (Digits == 3 || Digits == 5)
    {gi_BrokerDecimal = 10;}
     //       
    else
    {gi_BrokerDecimal = 1;}
    StopLoss = StopLoss * gi_BrokerDecimal;
    TakeProfit = TakeProfit * gi_BrokerDecimal;
    Slip = Slip * gi_BrokerDecimal;
//----
    if ((PrintCom || ShowCommentInChart) && !IsOptimization())
    {gb_InfoPrint = True;}
    if (IsTesting())
    {HideTestIndicators (FALSE);}
//----
    WorkCount = 0;
    ArrayResize (WorkSymbol, 100);
    int i1 = 0, i2 = 0;
    //    1-  
    i2 = StringFind (ListSymbol, ",", i1);
    while (i2 > 0)
    {
        WorkSymbol[WorkCount] = StringSubstr (ListSymbol, i1, i2 - i1);
        WorkCount++;
        i1 = i2 + 1;
        i2 = StringFind (ListSymbol, ",", i1 + 1);
    }
    WorkSymbol[WorkCount] = StringSubstr (ListSymbol, i1);
    WorkCount++;
    for (int l_int = 0; l_int < WorkCount; l_int++)
    {ls_inf = StringConcatenate (ls_inf, WorkSymbol[l_int], "; ");}
    Print (ls_inf);
    if (IsTesting() || IsOptimization())
    {WorkCount = 1;}
    ArrayResize (WorkSymbol, WorkCount);
    ArrayResize (WorkOp, WorkCount);
    ArrayResize (WorkPips, WorkCount);
    ArrayResize (WorkSort, WorkCount);
    ArrayResize (WorkCorr, WorkCount);
    ArrayResize (WorkTicket, WorkCount);

    ArrayInitialize (WorkOp, -1);
    ArrayInitialize (WorkSort, -1);
    ArrayInitialize (WorkCorr, 0);
    ArrayInitialize (WorkTicket, -1);
    if (gd_MinEquity == 0.0)
    { //         
        gd_MinEquity = AccountBalance();
        GlobalVariableSet (gs_NameGV + "_#min_EQUITY", DS0 (gd_MinEquity));
    }
    if (gd_MinMargin == 0.0)
    { //         
        gd_MinMargin = AccountBalance();
        GlobalVariableSet (gs_NameGV + "_#min_Margin", DS0 (gd_MinMargin));
    }
    if (gd_BeginBalance == 0.0)
    {
        gd_BeginBalance = AccountBalance();
        GlobalVariableSet (gs_NameGV + "_#BeginBalance", DS0 (gd_BeginBalance));
    }
//----
    //       
    if (Close_Trade_Symbol != "")
    {
        //       
        if (Close_Trade_Symbol == "ALL")
        {
            CloseOrderAll (Magic);
            return (0);
        }
        int li_Close = -1;
        for (gi_int = 0; gi_int < WorkCount; gi_int++)
        {
            if (WorkSymbol[gi_int] == Close_Trade_Symbol)
            {
                li_Close = gi_int;
                break;
            }
        }
        if (li_Close >= 0)
        {Order_Close (Close_Trade_Symbol, Magic);}
    }
//----
    if (IsTesting() || IsOptimization())
    {
        RealTrade = False;
    }
    else
    {
        fGlobalVariableGet(); //         
        if (new_Day != TimeDayOfWeek (TimeCurrent()))
        {
            if (!fGetHistory (500)) //      
            {
                ls_inf = "     !!!";
                Print (ls_inf);
                fGetLastError (Array_Com, " `fGetHistory()`. ", 4);
            }
        }
    }
//----
    return (0);
}
//+------------------------------------------------------------------+
int deinit()
{
    string ls_msg;
    int li_hist_ord;
    double li_tmp_Pribul;
    if (!RealTrade)
    {fGlobalVariableDel();}
    else
    {fSetGlobalVariable();}
//----
    gs_INF = " :\n";
    ls_msg = "    :";
    gi_History = 0;
    gd_Pribul = 0;
    for (gi_SMB = 0; gi_SMB < WorkCount; gi_SMB++)
    {
         li_tmp_Pribul = CalculatePribulMulti (li_hist_ord, Magic, WorkSymbol[gi_SMB]);
         gi_History += li_hist_ord;
         gd_Pribul += li_tmp_Pribul;
         ls_msg = fPrepareComment (StringConcatenate (ls_msg, "\n", WorkSymbol[gi_SMB], ": Pribul = $", DS0 (gd_Pribul), "; History = ", li_hist_ord, " "), ShowCommentInChart);
    }
    fPrintAndShowComment (fPrepareComment (StringConcatenate (gs_INF, "  = $", DS0 (gd_Pribul),
    "; MaxProsadka = $", DS0 (gd_MaxProsadka), "; History = ", gi_History, " \n", 
    "MaxZalog = $", DS0 (gd_MaxZalog), "; MinEquity = $", DS0 (gd_MinEquity),  "; MinMargin = $", DS0 (gd_MinMargin)),
    ShowCommentInChart), ShowCommentInChart, false, Array_Com, 0);
    fPrintAndShowComment (ls_msg, ShowCommentInChart, false, Array_Com, 2);
    if (ShowCommentInChart)
    {fComInChart (Array_Com);}
//----
    if (!SemaphoreOn)
    {return (0);}
    else
    {SemaphoreDeinit ("TRADECONTEXT");}
//----
    return (1);
}
//+------------------------------------------------------------------+
int start()
{
//----
    fClose_Control();
    fGet_Statistic();
    fRun_GetHistory();
//----
    if (CheckNewBar)
    {
        if (!WorkNewBar())
        {return (0);}
    }
    if (Lot == 0)
    {Lot = MarketInfo (Symbol(), MODE_MINLOT);}
    fRun_Statistics();  
    fRun_Sort();
    fRun_Correlation (WorkSort[0]);
    fRun_Trade (Magic);
    fGetLastError (Array_Com, "  start(). ", 4);
//----
    return (0);
}
//+----------------------------------------------------------------------------+
void fComInChart (string Com_Array[7])
{
    switch (Use_TraillingProfit)
    {
        case 0:
            Comment ("=======================================================\n",
            Com_Array[0], "\n",
            Com_Array[1], "\n",
                     "*******************************************************\n",
            Com_Array[2], "\n",
            Com_Array[3], "\n",
                     "=======================================================\n",
            Com_Array[4], "\n");
            break;
        case 1:
            Array_Com[1] = StringConcatenate (" TrailingProfit: Start = $", Trail_Start, "; Value = $", Trail_Value);
            Comment ("=======================================================\n",
            Com_Array[0], "\n",
            Com_Array[1], "\n",
                     "*******************************************************\n",
            Com_Array[2], "\n",
            Com_Array[3], "\n",
            Com_Array[6], "\n",
                     "=======================================================\n",
            Com_Array[4], "\n",
            Com_Array[5], "\n");
            break;
    }
//----
    return;
}
//+----------------------------------------------------------------------------+
void fRun_GetHistory()
{
    if (new_Day != TimeDayOfWeek (TimeCurrent()))
    {
        if (!fGetHistory (25))
        {
            gs_msg = "     !!!";
            Print (gs_msg);
            Comment (gs_msg);
            fGetLastError (Array_Com, " `fGetHistory()`. ", 4);
        }
        else
        {
            new_Day = TimeDayOfWeek (TimeCurrent());
            GlobalVariableSet (gs_NameGV + "_#new_Day", new_Day);
        }
    }
    return;
}
//+----------------------------------------------------------------------------+
void fClose_Control()
{
    if (Use_TraillingProfit == 1)
    {
        if (TrailingProfit (MinProfit, Trail_Start, Trail_Value, gd_Profit, Array_Com))
        {
            CloseOrderAll (Magic);
            WorkPrevTime = Time[1]; //       
        }
    }
    if (gd_Profit >= MaxProfit)
    {CloseOrderAll (Magic);}
//----
    //       ,   
    if (AccountBalance() * RiskDepoPercent / 100 < MathAbs (AccountProfit()))
    {
        CloseOrderAll (Magic);
        gs_Close = fPrepareComment (StringConcatenate ("BalanceControl():         RiskDepoPercent! (", WindowExpertName(), ")."), gb_InfoPrint);
        fPrintAndShowComment (gs_Close, ShowCommentInChart, PrintCom, Array_Com, 3);
    }
//----
    return;
}
//+----------------------------------------------------------------------------+
void fGet_Statistic()
{
    string ls_txt;
    int li_hist_ord, li_tmp_ord[3];
    double ld_tmp_Profit[3], ld_tmp_Lot[3], li_tmp_Pribul;
//----      
    gd_MaxZalog = MathMax (gd_MaxZalog, AccountMargin());
    gd_MinEquity = MathMin (gd_MinEquity, AccountEquity());
    gd_MinMargin = MathMin (gd_MinMargin, AccountFreeMargin());
//----
    //for (gi_SMB = 0; gi_SMB < WorkCount; gi_SMB++)
    //{MyPositions (WorkSymbol[], Magic, gi_SMB, int& Ord[3], double& dProfit[3], double& dTradeLots[3]);}
    gs_INF = " :\n";
    gd_Profit = fGetProfit (Magic);
    gd_MaxProsadka = MathMin (gd_MaxProsadka, gd_Profit);
    SetGlobalVariableMIN (gs_NameGV + "_#PROSADKA", gd_MaxProsadka);
    if (fCCV_I (OrdersHistoryTotal(), 0))
    {gd_Pribul = CalculatePribulMulti (gi_History, Magic);}
    //    
    fPrintAndShowComment (fPrepareComment (StringConcatenate (gs_INF, "Profit = $", DS0 (gd_Profit),
    "; MaxProsadka = $", DS0 (gd_MaxProsadka), "; Pribul = $", DS0 (gd_Pribul), "; History = ", gi_History, " \n", 
    "MaxZalog = $", DS0 (gd_MaxZalog), "; MinEquity = $", DS0 (gd_MinEquity),  "; MinMargin = $", DS0 (gd_MinMargin)),
    ShowCommentInChart), ShowCommentInChart, false, Array_Com, 0);
    check_order (Magic);
    ls_txt = "   :";
    for (gi_SMB = 0; gi_SMB < WorkCount; gi_SMB++)
    {
        if (WorkTicket[gi_SMB] > 0)
        {
            MyPositions (WorkSymbol[gi_SMB], Magic, gi_SMB, li_tmp_ord, ld_tmp_Profit, ld_tmp_Lot);
            li_tmp_Pribul = CalculatePribulMulti (li_hist_ord, Magic, WorkSymbol[gi_SMB]);
            ls_txt = fPrepareComment (StringConcatenate (ls_txt, "\n", WorkSymbol[gi_SMB], ": Profit = $", DS0 (ld_tmp_Profit[2]), "; Pribul[", li_hist_ord, "] = $", DS0 (li_tmp_Pribul), "; Pips = ", WorkPips[gi_SMB]), ShowCommentInChart);
        }
    }
    fPrintAndShowComment (ls_txt, ShowCommentInChart, false, Array_Com, 2);
    if (ShowCommentInChart)
    {fComInChart (Array_Com);}
    return;
}
//+------------------------------------------------------------------+
void  fGetLastError (string& Com_Array[], string Com = "", int index = -1)
{
    int err = GetLastError();
    string ls_err;
    if (err > 0)
    {
        ls_err = StringConcatenate (Com, ErrorDescription_RUS (err));
        Print (ls_err);
        if (index >= 0)
        {Com_Array[index] = ls_err;}
    }
}
//+------------------------------------------------------------------+
void check_order (int MG)
{
    ArrayInitialize (WorkTicket, -1);
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
        {continue;}
        if (OrderMagicNumber() != MG)
        {continue;}
        for (int j = 0; j < WorkCount; j++)
        {
            if (OrderSymbol() == WorkSymbol[j])
            {
                WorkTicket[j] = OrderTicket();
                break;
            }
        }
    }
}
//+------------------------------------------------------------------+
void fRun_Statistics()
{
    for (int i = 0; i < WorkCount; i++)
    {WorkPips[i] = CalculatePips (WorkSymbol[i]);}
}
//+------------------------------------------------------------------+
void fRun_Correlation (int Base)
{
    int i, j;
    double sx, sy, dx, dy, dxy, sb, co, sdxy;
   
    sx = iMA (WorkSymbol[Base], 0, CorrelationBar, 0, MODE_SMA, PRICE_CLOSE, Bar_Begins);
    dx = 0;
    for (i = 0; i < CorrelationBar; i++)  
    {dx += MathPow (iClose (WorkSymbol[Base], 0, Bar_Begins + i) - sx, 2);}
    for (j = 0; j < WorkCount; j++)
    {
        if (Base == j)
        {WorkCorr[j] = Revers_Otkat;}
        else
        {
            sy = iMA (WorkSymbol[j], 0, CorrelationBar, 0, MODE_SMA, PRICE_CLOSE, Bar_Begins);
            dy = 0;
            dxy = 0;
            for (i = 0; i < CorrelationBar; i++)
            {
                dy += MathPow (iClose (WorkSymbol[j], 0, Bar_Begins + i) - sy, 2);
                dxy += (iClose (WorkSymbol[Base], 0, Bar_Begins + i) - sy) * (iClose (WorkSymbol[j], 0, Bar_Begins + i) - sy);
            }
            sdxy = MathSqrt (dx * dy);
            WorkCorr[j] = 0;
            if (sdxy != 0)
            {
                dxy /= sdxy;
                if (dxy > 0.7)
                {WorkCorr[j] = Revers_Otkat;}
                if (dxy < -0.7)
                {WorkCorr[j] = -Revers_Otkat;}
            }         
        }
    }
    fGetLastError (Array_Com, " `fRun_Correlation()`. ", 4);
}
//+------------------------------------------------------------------+
double CalculatePips (string Sym)
{
    double ld_Point, m, m_now, m_pips;
    int cnt;
    string ls_msg = fPrepareComment (" `CalculatePips()`. ", ShowCommentInChart);
    cnt = 0;
    if (StringLen (Sym) == 0)
    {return (0);}
    ld_Point = dPoint (Sym);
    if (ld_Point == 0)
    {return (0);}
    while (m_pips == 0)
    {
        m_pips = (MarketInfo (Sym, MODE_BID) - iOpen (Sym, 0, ShiftBack)) / ld_Point;
        cnt++;
        if (cnt > 10)
        {
            ls_msg = fPrepareComment (StringConcatenate ("     ", Sym, ".    !!!"), ShowCommentInChart);
            break;
        }
    }
    fGetLastError (Array_Com, ls_msg, 4);
//----
    return (m_pips);
}
//+------------------------------------------------------------------+
void fRun_Sort()
{
    int i, j, tmp;
//----
    for (i = 0; i < WorkCount; i++)
    {WorkSort[i] = i;}
   
    for (i = 0; i < WorkCount; i++)
    {
		for (j = i + 1; j < WorkCount; j++)
		{
			if (WorkPips[WorkSort[i]] < WorkPips[WorkSort[j]])
			{
				tmp = WorkSort[j]; 
				WorkSort[j] = WorkSort[i]; 
				WorkSort[i] = tmp;
			}
		}
	}
}
//+------------------------------------------------------------------+
bool analyze_trades()
{
    int i, sp, sm;
    sp = 0;
    sm = 0;
//----
    for (i = 0; i < WorkCount; i++)
    {
        if (WorkCorr[WorkSort[i]] == 1)
        {      
            if (WorkPips[WorkSort[i]] > 0)
            {sm++;}
            sp++;
        }
    }
    if (sp == 0 || sp != sm)
    {return (true);}
//----
    return (false);
}
//+------------------------------------------------------------------+
void fRun_Trade (int MG)
{
    int cnt_BUY, cnt_SELL;
    string ls_SELL, ls_BUY, znak;
    //  
    cnt_BUY = 0;
    cnt_SELL = 0;
    ls_SELL = "";
    ls_BUY = "";
    if (AccountBalance() <= 0)
    {return;}
    for (int i = 0; i < WorkCount; i++)
    {
        if (WorkTicket[i] == -1)
        {continue;}
        OrderSelect (WorkTicket[i], SELECT_BY_TICKET);
        if (OrderCloseTime() > 0)
        {WorkTicket[i] = -1;}
        else
        {
            if (CheckNewBar) //      
            {
                if (TimeMinute (TimeCurrent() - OrderOpenTime()) < Period())
                {return;}
            }
            if (OrderType() == OP_SELL && (WorkCorr[i] == 1 || WorkCorr[i] == 0))
            {
                if (Order_Close (WorkSymbol[i], MG, OP_SELL))
                {
                    znak = IIFs (cnt_SELL == 0, "", "/");
                    WorkTicket[i] = -1;
                    ls_SELL = fPrepareComment (StringConcatenate (ls_SELL, znak, WorkSymbol[i]), gb_InfoPrint);
                    cnt_SELL++;
                }
            }
            if (OrderType() == OP_BUY && (WorkCorr[i] == -1 || WorkCorr[i] == 0))
            {
                if (Order_Close (WorkSymbol[i], MG, OP_BUY))
                {
                    znak = IIFs (cnt_BUY == 0, "", "/");
                    WorkTicket[i] = -1;
                    ls_BUY = fPrepareComment (StringConcatenate (ls_BUY, znak, WorkSymbol[i]), gb_InfoPrint);
                    cnt_BUY++;
                }
            }
        }
    }
    gs_msg = fPrepareComment (StringConcatenate (" ", cnt_BUY, "-BUY: ", ls_BUY, "  ", cnt_SELL, "-SELL: ", ls_SELL, " ."), gb_InfoPrint && (cnt_BUY > 0 || cnt_SELL > 0));
    fPrintAndShowComment (gs_msg, gb_InfoPrint, PrintCom, Array_Com, 3);
    //  
    cnt_BUY = 0;
    cnt_SELL = 0;
    ls_SELL = "";
    ls_BUY = "";
    for (i = 0; i < WorkCount; i++)
    {
        if (WorkTicket[i] >= 0 || WorkCorr[i] == 0)
        {continue;}
        fCheckMargin (gd_BeginBalance, StopMarginPercent, RiskDepoPercent);
        if (gb_Pause) //     -     !!!
        {return;}
        if (WorkCorr[i] == 1)
        {
            znak = IIFs (cnt_BUY == 0, "", "/");
            WorkTicket[i] = Order_Open (WorkSymbol[i], MG, OP_BUY);
            ls_BUY = fPrepareComment (StringConcatenate (ls_BUY, znak, WorkSymbol[i]), gb_InfoPrint && WorkTicket[i] > 0);
            cnt_BUY++;
        }
        else
        {
            znak = IIFs (cnt_SELL == 0, "", "/");
            WorkTicket[i] = Order_Open (WorkSymbol[i], MG, OP_SELL);
            ls_SELL = fPrepareComment (StringConcatenate (ls_SELL, znak, WorkSymbol[i]), gb_InfoPrint && WorkTicket[i] > 0);
            cnt_SELL++;
        }
    }
    gs_msg = fPrepareComment (StringConcatenate (" ", cnt_BUY, "-BUY: ", ls_BUY, "  ", cnt_SELL, "-SELL: ", ls_SELL, " .   ", WorkSort[0]), gb_InfoPrint && (cnt_BUY > 0 || cnt_SELL > 0));
    fPrintAndShowComment (gs_msg, gb_InfoPrint, PrintCom, Array_Com, 2);
}
//+------------------------------------------------------------------+
double dPoint (string sym)
{
    double ld_Point = MarketInfo (sym, MODE_POINT);
    if (ld_Point == 0)
    {ld_Point = 1 / MathPow (10, MarketInfo (sym, MODE_DIGITS));}
//----
    return (ld_Point);
}
//+------------------------------------------------------------------+
bool WorkNewBar()
{
    int NewTime = Time[0];
    if (WorkPrevTime == NewTime)
    {return (false);}
    WorkPrevTime = NewTime;
//----
    return (true);
}
//+------------------------------------------------------------------+
//   
//+------------------------------------------------------------------+
double IIFd (bool A, double B, double C)
{
    if (A)
    {return (B);}
//----
    return (C);
}
//+------------------------------------------------------------------+
color IIFc (bool A, color B, color C)
{
    if (A)
    {return (B);}
//----
    return (C);
}
//+------------------------------------------------------------------+
string IIFs (bool A, string B, string C)
{
    if (A)
    {return (B);}
//----
    return (C);
}
//+------------------------------------------------------------------+
//   
//+------------------------------------------------------------------+
int Order_Open (string Sym, int MG, int OP)
{
    color lc_color;
    if (!CheckSymbol (Sym))
    {return (-1);}
    RefreshRates();

    int cmd = IIFd (OP == OP_BUY, 1, -1);
    double ld_ask = MarketInfo (Sym, MODE_ASK);
    double ld_bid = MarketInfo (Sym, MODE_BID);
    double ld_point = dPoint (Sym);
    double ld_digits = MarketInfo (Sym, MODE_DIGITS);
    double price = IIFd (OP == OP_BUY, ld_ask, ld_bid);
    double ld_sl = NormalizeDouble (IIFd (StopLoss == 0, 0, price - cmd * StopLoss * ld_point), ld_digits);
    double ld_tp = NormalizeDouble (IIFd (TakeProfit == 0, 0, price + cmd * TakeProfit * ld_point), ld_digits);
    lc_color = IIFc (OP == OP_BUY, Blue, Red);
    string ls_comment = WorkSymbol[WorkSort[0]];
    int ticket = OrderSendReliable (Sym, OP,  Lot, price, Slip, ld_sl, ld_tp, ls_comment, MG, 0, lc_color); 
    fGetLastError (Array_Com, " `Order_Open()`. ", 4);
//----
    return (ticket);
}
//+------------------------------------------------------------------+
bool Order_Close (string WorkSymbol, int MG, int OP = -1)
{
    bool res = false;
    color lc_color;
//----
    for (int i = OrdersTotal() - 1;  i >= 0;  i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
        {continue;}
        if (OrderMagicNumber() != MG)
        {continue;}
        if (OrderType() != OP && OP != -1)
        {continue;}
      
        RefreshRates();
      
        double ld_ask = MarketInfo (OrderSymbol(), MODE_ASK);
        double ld_bid = MarketInfo (OrderSymbol(), MODE_BID);
        double ld_digits = MarketInfo (OrderSymbol(), MODE_DIGITS);
        double ClosePrice = NormalizeDouble (IIFd (OrderType() == OP_BUY, ld_bid, ld_ask), ld_digits);
        lc_color = IIFc (OrderType() == OP_BUY, Green, Magenta);
        res = OrderCloseReliable (OrderTicket(), OrderLots(), ClosePrice, Slip, lc_color);
    }
    fGetLastError (Array_Com, " `Order_Close()`. ", 4);
    return (res);
}
//+------------------------------------------------------------------+
//          
//+------------------------------------------------------------------+
/*int Order_Count_Calculate (string WorkSymbol, int MG, int OP = -1)
{
    ArrayInitialize (Order_Count, 0);
    for (int i = OrdersTotal() - 1;  i >= 0;  i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
        {continue;}
        if (OrderSymbol() != WorkSymbol)
        {continue;}
        if (OrderMagicNumber() != MG)
        {continue;}
        if (OrderType() != OP && OP != -1)
        {continue;}
        Order_Count[OrderType()]++;
    }
    if (OP != -1)
    {return (Order_Count[OP]);}
}*/
//+------------------------------------------------------------------+
bool CheckSymbol (string WorkSymbol)
{
    if ((IsTesting() || IsOptimization()) && WorkSymbol != Symbol())
    {return (false);}
//----
    return (true);
}
//+------------------------------------------------------------------+
void CloseOrderAll (int MG)
{
    color lc_color;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
        {continue;}
        if (OrderMagicNumber() != MG)
        {continue;}
        RefreshRates();
      
        double ld_ask = MarketInfo (OrderSymbol(), MODE_ASK);
        double ld_bid = MarketInfo (OrderSymbol(), MODE_BID);
        double ld_digits = MarketInfo (OrderSymbol(), MODE_DIGITS);
        double ClosePrice = NormalizeDouble (IIFd (OrderType() == OP_BUY, ld_bid, ld_ask), ld_digits);
        lc_color = IIFc (OrderType() == OP_BUY, Green, Magenta);
        OrderCloseReliable (OrderTicket(), OrderLots(), ClosePrice, Slip, lc_color);
    }
    fGetLastError (Array_Com, " `CloseOrderAll()`. ", 4);
}
//+------------------------------------------------------------------+
double fGetProfit (int MG)
{
    double ld_Profit = 0.0;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
        {continue;}
        if (OrderMagicNumber() != MG)
        {continue;}
        ld_Profit += OrderProfit() + OrderSwap() + OrderCommission();
    }
//----
    return (ld_Profit);
}
//+------------------------------------------------------------------+
bool fGetHistory (int cnt_Bars)
{
    string msg, symbol;
    int l_int, j, li_Period = Period();
    double ld_Par1, ld_Par2, ld_Par3, ld_Par4;
//----
    if (!IsCondition())
    {return (false);}
    for (l_int = 0; l_int < WorkCount; l_int++) 
    {
        symbol = WorkSymbol[l_int];
        msg = StringConcatenate ("\n  ", symbol, ", ", GetNameTF (li_Period));
        Comment (msg);
        for (j = cnt_Bars; j >= 0; j--) 
        {
            ld_Par1 = iClose (symbol, li_Period, j + 1);
            ld_Par2 = iOpen (symbol, li_Period, j);
            ld_Par3 = iHigh (symbol, li_Period, j + 1);
            ld_Par4 = iLow (symbol, li_Period, j);
        }
        Sleep (50);
        msg = StringConcatenate ("\n  ", symbol, " !");
        Comment (msg);
        Sleep (750);
    }
    msg = StringConcatenate ("\n   ", WorkCount, "   . C  : ", AccountNumber()); 
    Comment (msg);
    return (true);
}
//+------------------------------------------------------------------+
bool IsCondition()
{
    string msg2;
    bool result = true;
    string title2 = "";
    if (AccountNumber() > 0) 
    {title2 = AccountNumber() + ": " + title2;}
//----
    if (!IsConnected())
    {
        msg2 = "\n    !!!";
        result = false;
    }
    if (!IsDllsAllowed())
    {
        if (!result)
        {
            msg2 = StringConcatenate (title2, msg2, "\n     -= DLL=- !!!");
            result = false;
        }
    }
    Comment (msg2);
//----
    return (result);
}
//+----------------------------------------------------------------------------+
//|                                            |
//+----------------------------------------------------------------------------+
string GetNameTF (int TF)
{
    switch (TF)
    {
        case PERIOD_M1:  return ("M1");
		case PERIOD_M5:  return ("M5");
		case PERIOD_M15: return ("M15");
		case PERIOD_M30: return ("M30");
		case PERIOD_H1:  return ("H1");
		case PERIOD_H4:  return ("H4");
		case PERIOD_D1:  return ("D1");
		case PERIOD_W1:  return ("W1");
		case PERIOD_MN1: return ("Mth1");
		default:		 return ("UnknownPeriod");
	}
}
//+----------------------------------------------------------------------------+
//  Profit  Magic                                                |
// dt - 0- ,                                      |
//+----------------------------------------------------------------------------+
void MyPositions (string Sym, int Magic, int iv, int& Ord[3], double& dProfit[3], double& dTradeLots[3], datetime dt = 0)
{
    int l_int, total = OrdersTotal();
//----
    for (l_int = 0; l_int < 3; l_int++)
    {
        dProfit[l_int] = 0.0;
        dTradeLots[l_int] = 0.0;
        Ord[l_int] = 0;
    }
//----
    for (l_int = total - 1; l_int >= 0; l_int--)
    {
        if (!OrderSelect (l_int, SELECT_BY_POS, MODE_TRADES))
        {
            Print ("    OrderSelect()   MyPositions(): ", GetLastError(), " (", OrderTicket(), ").");
            return (0);
        }
        if (OrderSymbol() == Sym && OrderMagicNumber() == Magic)
        {
            if (OrderType() == OP_BUY || OrderType() == OP_SELL)
            {
                if (dt < OrderOpenTime() && dt != 0)
                {continue;}
                dProfit[2] += OrderProfit() + OrderSwap() + OrderCommission();
                dTradeLots[2] += OrderLots();
                
                if (OrderType() == OP_BUY)
                {
                    Ord[0]++;
                    dProfit[0] += OrderProfit() + OrderSwap() + OrderCommission();
                    dTradeLots[0] += OrderLots();
                }
                
                if (OrderType() == OP_SELL)
                {
                    Ord[1]++;
                    dProfit[1] += OrderProfit() + OrderSwap() + OrderCommission();
                    dTradeLots[1] += OrderLots();
                }
            }
        }
    }
//----
    Ord[2] = Ord[0] + Ord[1];  //     
    //gd_MaxProsadka[iv] = MathMin (gd_MaxProsadka[iv], dProfit[2]);
//----
    return;
}
//+----------------------------------------------------------------------------+
//         
//+----------------------------------------------------------------------------+
string fPrepareComment (string sText = "", bool bConditions = false)
{
    if (bConditions && StringLen (sText) > 0)
    {return (sText);}
}
//+----------------------------------------------------------------------------+
//       
//+----------------------------------------------------------------------------+
void fPrintAndShowComment (string Text, bool All_Conditions, bool Print_Conditions, string& s_Show[], int ind = -1)
{
    if (All_Conditions && StringLen (Text) > 0)
    {
        if (ind >= 0)
        {s_Show[ind] = Text;}
        if (Print_Conditions)
        {Print (Text);}
    }
    return;
}
//+----------------------------------------------------------------------------+
bool TrailingProfit (int TrailStopMin, int TrailStart, int TrailValue, double dProfit, string& Info[])
{
    static double MinProfit, MaxProfit;
    static int cur_TrailValue, cur_TrailStart, cur_TrailStopMin;
    string ls_txt, ls_FuncName = "TrailingProfit()";
//---- 
    cur_TrailValue = TrailValue;
    cur_TrailStart = TrailStart;
    if (MinProfit > 0)
    {cur_TrailStopMin = MathMin (TrailStopMin, MinProfit);}
//---- 
    if (gi_flagTrailProfit == 0)
    {
        if (dProfit >= cur_TrailStart)
        {
            ls_txt = "";
            MinProfit = dProfit - cur_TrailValue; //   
            MaxProfit = MinProfit + cur_TrailValue; //   
            gi_flagTrailProfit = 1;
            gi_flag_NULLStops = 1;
            GlobalVariableSet (gs_NameGV + "_#flagTP", gi_flagTrailProfit);
            GlobalVariableSet (gs_NameGV + "_#NULLStops", gi_flag_NULLStops);
            //GlobalVariableSet (gs_Symbol[iu] + "_#TradeSTOP", gi_TradeSTOP[iu]);
            ls_txt = fPrepareComment (StringConcatenate (ls_FuncName, ":   TrailingProfit. flagTrailProfit = ", CheckBOOL (gi_flagTrailProfit), "."), gb_InfoPrint);
            fPrintAndShowComment (ls_txt, gb_InfoPrint, PrintCom, Info, 6);
            return (false);
        }
    }
    if (gi_flagTrailProfit == 1)
    {
        if (dProfit >= cur_TrailStart)
        {
            MinProfit = MathMax (MinProfit, dProfit - cur_TrailValue);
            MaxProfit = MathMax (MaxProfit, dProfit);
            ls_txt = fPrepareComment (StringConcatenate (ls_FuncName, ":    TrailProfit (UP = $", DS0 (MaxProfit), "; DOWN = $", DS0 (MinProfit), "), ProfitStart = ", DS0 (cur_TrailStart), "; flagTrailProfit = ", CheckBOOL (gi_flagTrailProfit), "."), gb_InfoPrint);
            fPrintAndShowComment (ls_txt, gb_InfoPrint, PrintCom && fCCV_D (ND0 (MaxProfit), 0), Info, 6);
        }
        if (dProfit < MinProfit)
        {
            if (MinProfit == cur_TrailStopMin)
            {ls_txt = fPrepareComment (StringConcatenate (ls_FuncName, ":    cur_ProfitMin[", TrailStopMin, "]  = $", DS0 (dProfit), "."), gb_InfoPrint);}
            if (MinProfit > cur_TrailStopMin)
            {ls_txt = fPrepareComment (StringConcatenate (ls_FuncName, ":   ,  = $", DS0 (dProfit), "."), gb_InfoPrint);}
            fPrintAndShowComment (ls_txt, gb_InfoPrint, PrintCom, Info, 6);
            MaxProfit = 0;
            MinProfit = 0;
            gi_flagTrailProfit = 0;
            //gi_TradeSTOP[iu] = -1;
            GlobalVariableSet (gs_NameGV + "_#flagTP", gi_flagTrailProfit);
            //GlobalVariableSet (gs_Symbol[iu] + "_#TradeSTOP", gi_TradeSTOP[iu]);
            //gs_fsoName = "TP";
            return (true);
        }
    }
    return (false);
}
//+----------------------------------------------------------------------------+
double ND0 (double v)
{return (NormalizeDouble (v, 0));}
//+----------------------------------------------------------------------------+
string DS0 (double v)
{return (DoubleToStr (v, 0));}
//+----------------------------------------------------------------------------+
//|    (.)                                 |
//+----------------------------------------------------------------------------+
string CheckBOOL (int M)
{
    string BOOL = " ...";
    switch (M)
    {
        case 0: return ("");
        case 1: return ("");
    }
    return (BOOL);
}
//+----------------------------------------------------------------------------+
//|      : Taras                                                          |
//+----------------------------------------------------------------------------+
//|    : 27.10.2009                                                      |
//|  : fControlChangeValue_D         |
//|  double                                                           |
//+----------------------------------------------------------------------------+
bool fCCV_D (double param, int ix)
{
    static double cur_param[20];
    
    if (cur_param[ix] != param)
    {
        cur_param[ix] = param;
        return (true);
    }
    return (false);
}
//+----------------------------------------------------------------------------+
//|      : Taras                                                          |
//+----------------------------------------------------------------------------+
//|    : 27.10.2009                                                      |
//|  : fControlChangeValue_I         |
//|  int                                                              |
//+----------------------------------------------------------------------------+
bool fCCV_I (int param, int ix)
{
    static int cur_param[20];
    
    if (cur_param[ix] != param)
    {
        //Print ("cur_param[", ix, "] = ", cur_param[ix], "; param = ", param);
        cur_param[ix] = param;
        return (true);
    }
    return (false);
}
//+----------------------------------------------------------------------------+
void fGlobalVariableDel()
{
    GlobalVariableDel (gs_NameGV + "_#flagTP");
    GlobalVariableDel (gs_NameGV + "_#NULLStops");
    GlobalVariableDel (gs_NameGV + "_#BeginBalance");
    GlobalVariableDel (gs_NameGV + "_#min_EQUITY");
    GlobalVariableDel (gs_NameGV + "_#min_Margin");
    GlobalVariableDel (gs_NameGV + "_#ZALOG");
}
//+----------------------------------------------------------------------------+
void fGlobalVariableGet()
{
    gd_MaxProsadka = GetGlobalVariable (gs_NameGV + "_#PROSADKA");
    gd_BeginBalance = GetGlobalVariable (gs_NameGV + "_#BeginBalance");
    gd_MinEquity = GetGlobalVariable (gs_NameGV + "_#min_EQUITY");
    gd_MinMargin = GetGlobalVariable (gs_NameGV + "_#min_Margin");
    new_Day = GetGlobalVariable (gs_NameGV + "_#new_Day");
    gi_flagTrailProfit = GetGlobalVariable (gs_NameGV + "_#flagTP");
}
//+----------------------------------------------------------------------------+
void fSetGlobalVariable()
{
    SetGlobalVariableMIN (gs_NameGV + "_#PROSADKA", gd_MaxProsadka);
    SetGlobalVariableMAX (gs_NameGV + "_#ZALOG", AccountMargin());
    SetGlobalVariableMIN (gs_NameGV + "_#min_EQUITY", AccountEquity());
    SetGlobalVariableMIN (gs_NameGV + "_#min_Margin", AccountFreeMargin());
    GlobalVariableSet (gs_NameGV + "_#min_EQUITY", gd_MinEquity);
    GlobalVariableSet (gs_NameGV + "_#min_Margin", gd_MinMargin);
}
//+----------------------------------------------------------------------------+
double GetGlobalVariable (string sName)
{
     double dParametr = 0.0;
     if (GlobalVariableCheck (sName) == false)
     {GlobalVariableSet (sName, 0.0);}
     else
     {dParametr = GlobalVariableGet (sName);}
     return (dParametr);
}
//+----------------------------------------------------------------------------+
void SetGlobalVariableMAX (string sName, double dVariable)
{
    double dParametr;
    if (GlobalVariableCheck (sName) == false)
    {GlobalVariableSet (sName, dVariable);}
    else
    {
        dParametr = GlobalVariableGet (sName);
        if (dVariable > dParametr)
        {GlobalVariableSet (sName, ND0 (dVariable));}
    }
    return;
}
//+----------------------------------------------------------------------------+
void SetGlobalVariableMIN (string sName, double dVariable)
{
    double dParametr;
    if (GlobalVariableCheck (sName) == false)
    {GlobalVariableSet (sName, dVariable);}
    else
    {
        dParametr = GlobalVariableGet (sName);
        if (dVariable < dParametr)
        {GlobalVariableSet (sName, ND0 (dVariable));}
    }
    return;
}
//+----------------------------------------------------------------------------+
//    Magic                                   |
// cnt_ord -                                         |
//+----------------------------------------------------------------------------+
double CalculatePribulMulti (int& cnt_ord, int Magic, string sym = "", int op = -1)
{
    int li_int, history_total = OrdersHistoryTotal();
    double pr = 0;
    cnt_ord = 0;

    for (li_int = 0; li_int < history_total; li_int++)
    {
        if (OrderSelect (li_int, SELECT_BY_POS, MODE_HISTORY)) 
        {
            if (OrderMagicNumber() == Magic && (OrderSymbol() == sym || sym == "")) 
            {
                if ((op < 0 || OrderType() == op) && OrderType() < 2) 
                {
                    pr += OrderProfit() + OrderSwap();
                    cnt_ord++;
                }
            }
        }
    }
    return (pr);
}
//+----------------------------------------------------------------------------+
void fCheckMargin (double d_BeginBalance, int i_StopMarginPercent, int i_RiskDepoPercent)
{
    bool Zapret, StopMargin, StopBalance;
    string ls_prichina, ls_fName = "CheckMargin()";
    
    StopMargin = AccountFreeMargin() / AccountEquity() * 100 <= i_StopMarginPercent;
    StopBalance = AccountBalance() / d_BeginBalance * 100 <= i_RiskDepoPercent;
    Zapret = (StopMargin || StopBalance);
    
    if (Zapret == true)
    {
        gb_Pause = True;
        ls_prichina = fPrepareComment ("     -   ", gb_InfoPrint && StopMargin);
        ls_prichina = fPrepareComment ("     -  ", gb_InfoPrint && StopBalance);
        fPrintAndShowComment (fPrepareComment (StringConcatenate (ls_fName, ": ", ls_prichina, " (FreeMargin = $", DS0 (AccountFreeMargin()), "; Equity = $", DS0 (AccountEquity()), ")", "; Balance = $", DS0 (AccountBalance()), "; BeginBalance = $", DS0 (d_BeginBalance), " (", WindowExpertName(), ")."), gb_InfoPrint),
        gb_InfoPrint, PrintCom && fCCV_I (Zapret, 1), Array_Com, 3);
    }
    else
    {
        gb_Pause = False;
        fPrintAndShowComment (fPrepareComment (StringConcatenate (ls_fName, ":     ,    -  (FreeMargin = $", DS0 (AccountFreeMargin()), "; Equity = $", DS0 (AccountEquity()), ")", "; Balance = $", DS0 (AccountBalance()), " (", WindowExpertName(), ")."), gb_InfoPrint),
        gb_InfoPrint, PrintCom && fCCV_I (Zapret, 2), Array_Com, 3);
    }
}

